;	Example of how to write a Printer command resource to be
;	used with microemacs 3.8M with the "User Special" Line
;	terminator option.  The user special routine actually gets
;	considerable freedom, since it takes care of all output of
;	text to the printer.
;
;	On entry:
;		a0 -> io Parameter block, set up with proper device
;			reference number for chosen serial driver
;			the ioMisc field of this parameter block
;			contains a pointer to a longword, which is 
;			an application global, unused for any other 
;			purpose
;		d0 contains an opcode, one of four below
;
;	On exit:
;		restore all but perhaps a0, a1, d0, and d1
;
	INITIALIZE	equ 0
	DOLINE		equ 1
	ENDPAGE		equ 2
	BEGINPAGE	equ 3
	localvars	equ -8
	iopb		equ -4
	myopcode	equ -8
;
;	A copy of the C calling routine follows...
;
;int userprint(pb,myopcode,ePrc)
;ParmBlkPtr pb;
;int	myopcode;
;ProcPtr	ePrc;
;{
;	asm{
;		move.l	pb(a6),a0
;		move.w	myopcode(a6),d0
;		move.l	ePrc(a6),a1
;		jsr		(a1)
;	}
;}
;			
Include 	mds:library:newlib.d	; Use System and ToolBox traps

	RESOURCE	'ePrc' 777 'emacs PrintHandler' 24
;	Resource ID 777, locked
entry:
	link	a6,#localvars		;get a stack frame
	move.l	a0,iopb(a6)		;save parameter block address
	move.w	d0,myopcode(a6)		;save opcode, just in case
	cmp.w	#INITIALIZE,d0		;test for printer init
	beq	done			;the Tandy requires nothing special
	cmp.w	#DOLINE,d0		;test for print a line
	beq	printline		;yes, do it
	cmp.w	#ENDPAGE,d0		;test for end of page
	beq	header			;yes, do it
	cmp.w	#BEGINPAGE,d0		;test for head of page
	beq	footer			;do a footer
done:					;default, just quit
	unlk	a6			;unlink our stack frame
	rts				;get out
printline:
	_write				;do the write
	move.l	iopb(a6),a0		;fetch parameter block again
	lea	endline,a1		;get endline string
	move.l	a1,ioBuffer(a0)		;put it in parameter block
	move.l	#1,ioReqCount(a0)	;one character
	_write				;put it out
	bra.s	done			;exit
header:					;same thing on my printer!
footer:
	lea	endline,a1		;get endline string
	move.l	a1,ioBuffer(a0)		;put it in parameter block
	move.l	#5,ioReqCount(a0)	;five characters
	_write				;put it out
	bra.s	done			;exit
endline:
	dc.b	13,13,13,13,13		;just a bunch of carriage returns


