{ BBS Utility program and documentation for all major BBS files }
{ Modify SecLev file - T R Teague - 17 Oct 86 }
{ This version works under Lisa Pascal/MPW }
{ modified for version 1.1 of WWIV Mac BBS - T R Teague - 1 Jan 87 }
{ modified for version 2.0 of WWIV Mac BBS - T R Teague - 22 Mar 87 }
{ modified for version 2.2 of WWIV Mac BBS - T R Teague - 25 May 87 }

{$DECL MPW}
{$DECL Debug}
{$SETC MPW := true}
{$SETC Debug := false}

program ModifySecLev;

uses
{$IFC MPW }
     MemTypes,
     QuickDraw,
     OSIntf,
     ToolIntf,
     PackIntf,
     PasLibIntf,
     IntEnv;
{$ELSEC}
     {$U -#11-obj-MemTypes } MemTypes,
     {$U -#11-obj-QuickDraw} QuickDraw,
     {$U -#11-obj-OSIntf   } OSIntf,
     {$U -#11-obj-ToolIntf } ToolIntf,
     {$U -#11-obj-PackIntf } PackIntf,
     {$U -#11-obj-WritelnWindow } WritelnWindow;
{$ENDC}

{$IFC Debug}
{$D+}
{$ELSEC}
{$D-}
{$ENDC}

{ Standard const's, types, vars for BBS files }

const
     strlen = 160; { length of string }
	 
     { added - TRT - 25 May 87 }
     { user-modifable resources }

     StrID = 1000;
     NumStrItems = 5;

     DLoadsStrID = 1001;
     MsgsStrID = 1002;
     numcomptypes = 11; { added for 2.2 - TRT - 21 Jun 87 }

type
     filetype = file; { untyped file-type for procedure parameter passing }

     strtype=string[strlen]; { string type }

{ enumerated list of user restrictions }
{ 
  logons 2/day ('L'), no chatting ('C'), unvalidated messages ('V'), no backspacing ('B'),
  can't change automsg/add to BBS list ('A'), can't post anonymous msgs ('*'),
  can't post at all ('P'), can't send send E-Mail ('E'), can't vote ('K'),
  can't auto-delete msgs ('M')
}
restrictions=(rlogon,rchat,rvalidate,rbackspace,ramsg,rpostan,
                   rpost,remail,rvoting,rmsg); 

     acrq='@'..'G'; { board access : none, A -> G - not really used }

{ emunerated user defaults : spinning cursor, onekey input, word wrap, screen pause }
     deflts=(spcsr,onekey,wordwrap,pause);

{ emunerated anon msg board types : no, yes, forced, dearabby }
     anontyp=(no,yes,forced,dearabby); 

{ enumerated security level types : can post, can E-Mail, can post anonymously, 
  can see anon names on msgs,  co-sysop, limited co-sysop }
     ansttype=(postn,emailn,pana,sanm,cosysop,lcosysop);

{ enumerated special user alerts : alert, can't ???, can't receive E-Mail }
     opts=(myalert,smw,nomail); 
     
	 { modified for version 1.1 & 2.0 }
	 pnr=record { phone no. info - for sysop's mini-terminal }
	       name:string[39]; { name of BBS service }
	       number:string[32]; { phone no. } 
	       hs:byte; { baud rate - 300/1200/2400/9600 }
	     end;
     slr=record { security level info }
           ttime:byte; { max. no. of mins allowed on }
           mallowed:integer; { max. no. of msgs allowed to be read }
           emails,posts:byte; { max. no. of E-Mail and msgs to be posted }
           anst:set of ansttype; { set of security level types  - see above }
         end;
     messages=record { msgs filename info  - e.g filename of form A-32767.1 }
                ltr:char; { board letter (i.e. A = board no. 1) }
                number:integer; { unique msg number }
                ext:byte; { unique msg number for filename extension (MS-DOS) }
              end;
     smalrec=record { names list of users }
               name:string[25]; { alias }
               number:integer; { user no. }
             end;
     userrec=record { user info }
               name:string[25]; { alias }
               realname:string[14]; { realname }
               deleted:boolean; { deleted flag }
               pw:string[8]; { password }
               ph:string[12]; { phone no. }
               waiting:byte; { no. of E-Mail msgs waiting }
               laston:string[10]; { last on date }
               loggedon:integer; { total no. of times logged on system }
               msgpost:integer; { total no. of msgs posted }
               emailsent:integer; { total no. of E-Mail msgs sent }
               feedback:integer; { total no. of feedback msgs sent }
               linelen:byte; { user's screen width }
               pagelen:byte; { user's screen height }
               defaults:set of deflts; { set of user defaults (on/off) - see above }
               ontoday:byte; { no. of times logged on today }
               illegal:byte; { no. of illegal logons today }
               cursor:string[10]; { spinning cursor (if any) "word" }
               sl:byte; { security level }
               ac:set of restrictions; { set of user restrictions (on/off) - see above }
               ar:set of acrq; { set of boards user has access to (on/off) - not really used - see above }
               qscan:array[1..19] of messages; { last msg Q-scanned for each 1 of 19 possible boards }
               qscn:array[1..19] of boolean; { configured Q-Scan flags for up to 19 boards }
               macro:array[1..2] of string[79]; { control-d & control-f macro expansions }
               comptype:byte; { computer type (1 -> numcomptypes) as set up elsewhere }
               option:set of opts; { set of user options (on/off) - see above }
               vote:array[1..9] of byte; { voted flags for up to 9 questions }
               sbn:byte; { "special board no." - user has rights to validate/delete msgs on board (0 = All) }
               dsl:byte; { download security level }
               uploads,downloads:integer; { No. of files uploaded/downloaded }
               uk,dk:integer; { No. of Kb's uploaded/downloaded }
             end;
      boardrec=record { msg board info }
                 name:string[25]; { board title }
                 filename:string[12]; { name of file used to hold msgs info }
                 sl:byte; { min. security level needed to access this board }
                 maxmsgs:byte; { max. no. of msgs allowed on this board }
                 pw:string[10]; { board password (if any) }
                 anonymous:anontyp; { type of anonymous access to this board - see above }
                 ar:acrq; { access required for this board (not really used) - see above }
                 key:char; { character required to reach this board - i.e. 1 -> 19, or this char }
               end;
      msgstat=(validated,unvalidated,deleted); { enumerated msg types - validated, unvalidated, deleted }
      messagerec=record { msgs info }
                   title:string[30]; { title of msg }
                   messagestat:msgstat; { msg type - see above }
                   message:messages; { msg filename info - see above }
                   owner:integer; { user no. of sender }
                   date:integer; { date posted }
                   mage:byte; { message age in days }
                 end;
      systatrec=record { status record }
                  boardpw:string[8]; { closed board password (if any) }
                  sysoppw:string[8]; { sysop's 2nd password }
                  hmsg:messages; { msg filename info - next avail. msg filename ??? }
                  users:integer; { no. of users currently on system }
                  lastdate:string[8]; { last date that system was used }
                  callernum:integer; { current/next caller no. }
                  activetoday:integer; { amount of time in mins that system was up }
                  callstoday:integer; { no. of calls today }
                  msgposttoday:integer; { no. of msgs posted today }
                  emailtoday:integer; { no. of E-Mail msgs sent today }
                  fbacktoday:integer; { no. of Feedback msgs sent today }
                  uptoday:integer; { no. of uploads today }
                  closedsystem:boolean; { closed system flag }
                end;
      mailrec=record { E-Mail info }
                title:string[30]; { title of msg }
                from,destin:integer; { user no. of sender, recipient }
                msg:messages; { msg filename info - see above }
                date:integer; { date sent }
                mage:byte; { message age in days }
              end;
      gft=record { G-Files info }
            num:integer; { section no. }
            title:string[40]; { G-File title }
            filen:string[12]; { G-File filename }
          end;
      charfil=text; { character file type }
      smr=record { small msg info }
            msg:strtype; { the msg }
            destin:integer; { user no. of recipient }
          end;
      vdatar=record { voting data info }
               question:string[79]; { question }
               numa:integer; { no. of answers }
               answ:array[0..9] of record { 10 possible answers }
                      ans:string[25]; { answer }
                      numres:integer; { number of users voting this answer }
                    end;
             end;
      ulrec=record { file section board data }
              name:string[25]; { name of board }
              filename:string[12]; { name of file that holds file section data }
              password:string[10]; { board password (if any) }
              dsl:byte; { min. security level needed to access this board }
              maxfiles:integer; { max. no. of files allowed in this board }
            end;
      ulfrec=record { uploaded file info }
               filename:string[12]; { filename }
               description:string[60]; { description }
               {res:array[1..17] of byte;} { reserved ??? }
	       realname : string[64]; { added for version 1.1 - MacBinary filename }
               ft:array[1..3] of byte; { filetype - not really used (MS-DOS) }
               blocks:integer; { size in blocks }
               owner:integer; { user no. of uploader }
               date:string[8]; { date uploaded }
               daten:integer; { day no. of the year when uploaded }
	       numdloads : integer; { added for version 1.1 }
             end;

var 
    (* { file vars for different types of files }
	
	sf:file of smalrec; { filename = gfiles\names.lst }
    uf:file of userrec; { filename = gfiles\user.lst }
    bf:file of boardrec; { filename = gfiles\boards.dat }
    mf:file of messagerec; { filename = gfiles\ + boards[board].filename }
    mailfile:file of mailrec; { filename = gfiles\email.dat }
    systatf:file of systatrec; { filename = gfiles\status }
    smf:file of smr; { filename = gfiles\shortmsg.dat }
    ulf : file of ulrec; { filename = gfiles\uploads.dat }
	ulff : file of ulfrec; { filename = gfiles\ + uboards[board].filename }
	fil : file of pnr; { filename = gfiles\numbers.trm }
    vdf : file of vdatar; { filename = gfiles\voting.dat }
	cf : file of smr; { filename = gfiles\chat.msg }
    g : file of gft; { filename = gfiles\gfiles.dat }
	fil : file of strtype; { filename = gfiles\laston.fil - names of last 8 callers }
	
    sysopf:charfil; { filename = gfiles\sysop.log, and gfiles\ysysop.log - today's & yesterday's logs }
	{ also other text files : gfiles\trashcan.txt - contains illegal names for aliases }
	{ gfiles\user.log - log of today's callers names }
	{ gfiles\votes.txt - output of voting data }
	{ gfiles\bbslist.msg - list of bbs's }
	{ gfiles\auto.msg - auto msg }
	*)
	
	{ modified - TRT - 25 May 87 }
	{actual variables used by this program }
	gfilespath : strtype;
	pathdloads : strtype;
	pathmsgs : strtype;

	msgspath : packed array [0..19] of string[80];
	dloadspath : packed array [0..19] of string[80];
	tempPtr : ^integer;
	DefaultWD : integer;
	UsingHFS : boolean;

	MyPoint : Point;
	BBSrefNum : integer;
	MyTypes : SFTypeList;
	MyReply : SFReply;
	IOError : OSErr;
	
	fw:integer;
        slf:file of slr; { filename = gfiles\seclev.dat }
        seclev:array[0..255] of slr;

{$IFC Debug}
{procedure CrashIt;    INLINE $A9FF;}
{$ENDC}

{ added - TRT - 25 May 87 }
procedure InitCommon;

var
   tempHandle : Handle;
   tempint : integer;

begin { initcommon }
   tempHandle := GetResource('STR#',StrID);
   if (ResError <> noErr) or (tempHandle = nil) then
   begin
      writeln;
      writeln('Sorry... couldn''t find the Resource STR# ID = ',StrID);
      writeln;
      writeln('Press mouse button to exit');
      repeat until button;
      exit(modifyseclev);
   end;

   for tempint := 1 to NumStrItems do
   begin { get user definable parameters from Resource file }

      case tempint of
      1 : ;
      2 : ;
      3 : begin
             GetIndString(tempstr,StrID,tempint);
             gfilespath := tempstr;
          end;
      4 : begin { modified - TRT - 20/12/86 }
             GetIndString(tempstr,StrID,tempint);
             pathdloads := tempstr;
          end;
      5 : begin
             GetIndString(tempstr,StrID,tempint);
             pathmsgs := tempstr;
          end;
      end; { cases }
   end;

   for tempint := 0 to 19 do
   { get user definable parameters from Resource file }
   begin
      GetIndString(tempstr,MsgsStrID,tempint + 1);
      if tempstr = '' then tempstr := pathmsgs;
      msgspath[tempint] := tempstr;
   end;

   for tempint := 0 to 19 do
   { get user definable parameters from Resource file }
   begin
      GetIndString(tempstr,DLoadsStrID,tempint + 1);
      if tempstr = '' then tempstr := pathdloads;
      dloadspath[tempint] := tempstr;
   end;

end; { initcommon }

begin
{$IFC Debug}
   {CrashIt;}
{$ENDC}
   InitGraf(@ThePort); { Init QuickDraw }

{$IFC MPW}
if IEStandalone then
{$ENDC}
    begin { not MPW Tool }
           InitWindows;	       { Init Window Manager - clear desktop & menu bar }
           InitFonts;	       { Init Font Manager }
           FlushEvents(everyEvent,0); { Throw away any stray events }
           TEInit;	      { Init TextEdit }
           InitMenus;	       { Init Menu Manager }
           InitDialogs(nil);

           DrawMenuBar;

           InitCursor;
   end;

{$IFC Debug}
{$IFC MPW}
   rewrite(debugger,'Dev:StdErr');
   PLSetVBuf(debugger,nil,_IONBF,0); { no buffering, for MPW }
{$ELSEC}
   rewrite(debugger,'.aout');
{$ENDC}
   lf := chr(32);
   writeln(debugger,'Debugging On...',lf);
{$ENDC}

{$IFC MPW}
   PLSetVBuf(output,nil,_IONBF,0); { no buffering, for MPW }
{$ELSEC}

   WWInit(25,80);

   SetRect(tempRect,20,50,500,300);
   WWNew(tempRect,'Modify SecLev',false,true,monaco,9);

{$ENDC}

    tempPtr := pointer($3F6); { fsFCBLen }
    UsingHFS := tempPtr^ > 0;
    IOError := GetVol(@tempstr,DefaultWD);

    { added - TRT - 25 May 87 }
    writeln;
    writeln('Choose the BBS File to Get Pathnames etc from');
    writeln;
 
    MyPoint.h := 90; MyPoint.v := 30;
    SFGetFile(MyPoint,'',nil,-1,MyTypes,nil,MyReply);
    if MyReply.good then
    begin
       if UsingHFS then
       begin
	  IOError := SetVol(nil,MyReply.vRefNum);
	  if IOError <> noErr then
	  begin
	     writeln;
	     writeln('I/O Error #',IOError,' while doing SetVol of ',MyReply.vRefNum);
	     writeln;
	  end;
       end;
 
       BBSrefNum := OpenResFile(MyReply.fName);
       if ResError <> noErr then
       begin
	  writeln;
	  writeln('Resource Error #',ResError,' while doing OpenResFile');
	  writeln;
       end;
 
       { IMPORTANT - do not call other CODE segments while BBS 
                     ResFile is open - it won't work! }
 
       InitCommon;
 
       if (BBSrefNum >= 0) then CloseResFile(BBSrefNum);
 
       if UsingHFS then
       begin
	  IOError := SetVol(nil,DefaultWD);
	  if IOError <> noErr then
	  begin
	     writeln;
	     writeln('I/O Error #',IOError,' while doing SetVol of ',DefaultWD);
	     writeln;
	  end;
       end;
 
       rewrite(slf,concat(gfilespath,'seclev.dat'));
       for fw := 0 to 255 do { these are the defaults used by the BBS for each security level }
	with seclev[fw] do
	begin
	  anst := [];
	
	  if fw < 10 then
	  begin
		 ttime := 1;
		 mallowed := 1;
		 emails := 0;
		 posts := 0;
	  end else
	  if fw < 18 then
	  begin
		 ttime := 10;
		 mallowed := 15;
		 emails := 0;
		 posts := 0;
	  end else
	  if fw = 18 then
	  begin
		 ttime := 5;
		 mallowed := 5;
		 emails := 0;
		 posts := 1;
	  end else
	  if fw = 19 then
	  begin
		 ttime := 10;
		 mallowed := 10;
		 emails := 1;
		 posts := 1;
	  end else
	  if fw < 25 then
	  begin
		 ttime := 15;
		 mallowed := 20;
		 emails := 2;
		 posts := 2;
	  end else
	  if fw < 30 then
	  begin
		 ttime := 17;
		 mallowed := 25;
		 emails := 2;
		 posts := 3;
	  end else
	  if fw < 35 then
	  begin
		 ttime := 20;
		 mallowed := 30;
		 emails := 2;
		 posts := 3;
	  end else
	  if fw < 40 then
	  begin
		 ttime := 25;
		 mallowed := 40;
		 emails := 3;
		 posts := 4;
	  end else
	  if fw < 45 then
	  begin
		 ttime := 30;
		 mallowed := 50;
		 emails := 4;
		 posts := 4;
	  end else
	  if fw < 50 then
	  begin
		 ttime := 35;
		 mallowed := 60;
		 emails := 4;
		 posts := 4;
	  end else
	  if fw < 55 then
	  begin
		 ttime := 40;
		 mallowed := 70;
		 emails := 5;
		 posts := 5;
	  end else
	  if fw < 60 then
	  begin
		 ttime := 45;
		 mallowed := 75;
		 emails := 5;
		 posts := 5;
	  end else
	  if fw < 65 then
	  begin
		 ttime := 50;
		 mallowed := 85;
		 emails := 5;
		 posts := 5;
	  end else
	  if fw < 70 then
	  begin
		 ttime := 55;
		 mallowed := 90;
		 emails := 5;
		 posts := 6;
	  end else
	  if fw < 75 then
	  begin
		 ttime := 60;
		 mallowed := 100;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana];
	  end else
	  if fw < 80 then
	  begin
		 ttime := 65;
		 mallowed := 115;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana];
	  end else
	  if fw < 90 then
	  begin
		 ttime := 65;
		 mallowed := 120;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana,sanm];
	  end else
	  if fw < 95 then
	  begin
		 ttime := 70;
		 mallowed := 150;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana,sanm,postn];
	  end else
	  if fw < 99 then
	  begin
		 ttime := 70;
		 mallowed := 200;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana,sanm,postn,emailn];
	  end else
	  if fw = 99 then
	  begin
		 ttime := 70;
		 mallowed := 200;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana,sanm,postn,emailn,lcosysop];
	  end else
	  if fw = 100 then
	  begin
		 ttime := 85;
		 mallowed := 300;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana,sanm,postn,emailn,cosysop];
	  end else
	  if fw < 200 then
	  begin
		 ttime := 90;
		 mallowed := 500;
		 emails := 6;
		 posts := 6;
		 anst := anst + [pana,sanm,postn,emailn,cosysop];
	  end else
	  if fw < 255 then
	  begin
		 ttime := 100;
		 mallowed := 1000;
		 emails := 10;
		 posts := 10;
		 anst := anst + [pana,sanm,postn,emailn,cosysop];
	  end else
	  begin { sysop }
		 ttime := 255;
		 mallowed := 32767;
		 emails := 255;
		 posts := 255;
		 anst := anst + [pana,sanm,postn,emailn,cosysop];
	  end;
	
	  slf^ := seclev[fw];
	  put(slf);
	end;

{$IFC MPW}
      close(slf);
{$ELSEC}
      close(slf,lock);
{$ENDC}
   end;
end.
